diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/test/type-id-test-suite.cc ns-3.31/src/core/test/type-id-test-suite.cc
--- ns-3.30.1/src/core/test/type-id-test-suite.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/test/type-id-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
@@ -36,8 +36,8 @@
 using namespace ns3;
 
 
-const std::string suite("type-id: ");
-  
+const std::string suite ("type-id: ");
+
 //----------------------------
 //
 // Test for uniqueness of all TypeIds
@@ -47,39 +47,41 @@
 public:
   UniqueTypeIdTestCase ();
   virtual ~UniqueTypeIdTestCase ();
+
 private:
   virtual void DoRun (void);
-  enum { HashChainFlag = 0x80000000};
+  enum
+  {
+    HashChainFlag = 0x80000000
+  };
 };
 
 UniqueTypeIdTestCase::UniqueTypeIdTestCase ()
   : TestCase ("Check uniqueness of all TypeIds")
-{
-}
+{}
 
 UniqueTypeIdTestCase::~UniqueTypeIdTestCase ()
-{
-}
+{}
 
 void
 UniqueTypeIdTestCase::DoRun (void)
 {
   cout << suite << endl;
   cout << suite << GetName () << endl;
-  
+
   // Use same custom hasher as TypeId
   ns3::Hasher hasher = ns3::Hasher ( Create<Hash::Function::Murmur3> () );
-  
+
   uint32_t nids = TypeId::GetRegisteredN ();
 
   cout << suite << "UniqueTypeIdTestCase: nids: " << nids << endl;
   cout << suite << "TypeId list:" << endl;
   cout << suite << "TypeId  Chain  hash          Name" << endl;
-  
+
   for (uint16_t i = 0; i < nids; ++i)
     {
       const TypeId tid = TypeId::GetRegistered (i);
-      cout << suite << "" << std::setw(6) << tid.GetUid ();
+      cout << suite << "" << std::setw (6) << tid.GetUid ();
       if (tid.GetHash () & HashChainFlag)
         {
           cout << "  chain";
@@ -108,7 +110,7 @@
                              TypeId::LookupByHash (tid.GetHash ()).GetUid (),
                              "LookupByHash returned different TypeId for "
                              << tid.GetName ());
-      
+
     }
 
   cout << suite << "<-- end TypeId list -->" << endl;
@@ -124,26 +126,28 @@
 public:
   CollisionTestCase ();
   virtual ~CollisionTestCase ();
+
 private:
   virtual void DoRun (void);
-  enum { HashChainFlag = 0x80000000};
+  enum
+  {
+    HashChainFlag = 0x80000000
+  };
 };
 
 CollisionTestCase::CollisionTestCase ()
   : TestCase ("Check behavior when type names collide")
-{
-}
+{}
 
 CollisionTestCase::~CollisionTestCase ()
-{
-}
+{}
 
 void
 CollisionTestCase::DoRun (void)
 {
   cout << suite << endl;
   cout << suite << GetName () << endl;
-  
+
   // Register two types whose hashes collide, in alphabetical order
   // Murmur3 collision from /usr/share/dict/web2
   string t1Name = "daemon";
@@ -157,11 +161,11 @@
 
   // Check that they are alphabetical: t1 name < t2 name
   NS_TEST_ASSERT_MSG_EQ ( (t1.GetHash () & HashChainFlag), 0,
-                         "First and lesser TypeId has HashChainFlag set");
+                          "First and lesser TypeId has HashChainFlag set");
   cout << suite << "collision: first,lesser  not chained: OK" << endl;
 
   NS_TEST_ASSERT_MSG_NE ( (t2.GetHash () & HashChainFlag), 0,
-                         "Second and greater TypeId does not have HashChainFlag set");
+                          "Second and greater TypeId does not have HashChainFlag set");
   cout << suite << "collision: second,greater    chained: OK" << endl;
 
 
@@ -189,7 +193,7 @@
    *
    *  None found in /usr/share/dict/web2
    */
-  
+
 }
 
 
@@ -209,15 +213,20 @@
   TracedValue<double> m_trace;
 
 public:
-  DeprecatedAttribute () : m_attr (0) { NS_UNUSED (m_attr); };
-  virtual ~DeprecatedAttribute () { };
+  DeprecatedAttribute ()
+    : m_attr (0)
+  {
+    NS_UNUSED (m_attr);
+  }
+  virtual ~DeprecatedAttribute ()
+  {}
 
   // Register a type with a deprecated Attribute and TraceSource
   static TypeId GetTypeId (void)
   {
     static TypeId tid = TypeId ("DeprecatedAttribute")
       .SetParent<Object> ()
-      
+
       // The new attribute
       .AddAttribute ("attribute",
                      "the Attribute",
@@ -260,7 +269,7 @@
                        "ns3::TracedValueCallback::Void",
                        TypeId::OBSOLETE,
                        "refactor to use 'trace'");
-    
+
     return tid;
   }
 
@@ -272,6 +281,7 @@
 public:
   DeprecatedAttributeTestCase ();
   virtual ~DeprecatedAttributeTestCase ();
+
 private:
   virtual void DoRun (void);
 
@@ -279,12 +289,10 @@
 
 DeprecatedAttributeTestCase::DeprecatedAttributeTestCase ()
   : TestCase ("Check deprecated Attributes and TraceSources")
-{
-}
+{}
 
 DeprecatedAttributeTestCase::~DeprecatedAttributeTestCase ()
-{
-}
+{}
 
 void
 DeprecatedAttributeTestCase::DoRun (void)
@@ -294,17 +302,17 @@
 
   TypeId tid = DeprecatedAttribute::GetTypeId ();
   cerr << suite << "DeprecatedAttribute TypeId: " << tid.GetUid () << endl;
-  
+
   //  Try the lookups
   struct TypeId::AttributeInformation ainfo;
   NS_TEST_ASSERT_MSG_EQ (tid.LookupAttributeByName ("attribute", &ainfo), true,
-                      "lookup new attribute");
+                         "lookup new attribute");
   cerr << suite << "lookup new attribute:"
        << (ainfo.supportLevel == TypeId::SUPPORTED ? "supported" : "error")
        << endl;
 
   NS_TEST_ASSERT_MSG_EQ (tid.LookupAttributeByName ("oldAttribute", &ainfo), true,
-                      "lookup old attribute");
+                         "lookup old attribute");
   cerr << suite << "lookup old attribute:"
        << (ainfo.supportLevel == TypeId::DEPRECATED ? "deprecated" : "error")
        << endl;
@@ -325,7 +333,7 @@
        << endl;
 }
 
-  
+
 //----------------------------
 //
 // Performance test
@@ -335,29 +343,31 @@
 public:
   LookupTimeTestCase ();
   virtual ~LookupTimeTestCase ();
+
 private:
   void DoRun (void);
   void DoSetup (void);
-  void Report (const std::string how, const uint32_t delta) const ;
+  void Report (const std::string how, const uint32_t delta) const;
 
-  enum { REPETITIONS = 100000 };
+  enum
+  {
+    REPETITIONS = 100000
+  };
 };
 
 LookupTimeTestCase::LookupTimeTestCase ()
   : TestCase ("Measure average lookup time")
-{
-}
+{}
 
 LookupTimeTestCase::~LookupTimeTestCase ()
-{
-}
+{}
 
 void
 LookupTimeTestCase::DoRun (void)
 {
   cout << suite << endl;
   cout << suite << GetName () << endl;
-  
+
   uint32_t nids = TypeId::GetRegisteredN ();
 
   int start = clock ();
@@ -368,7 +378,7 @@
           const TypeId tid = TypeId::GetRegistered (i);
           const TypeId sid = TypeId::LookupByName (tid.GetName ());
         }
-  }
+    }
   int stop = clock ();
   Report ("name", stop - start);
 
@@ -380,17 +390,17 @@
           const TypeId tid = TypeId::GetRegistered (i);
           const TypeId sid = TypeId::LookupByHash (tid.GetHash ());
         }
-  }
+    }
   stop = clock ();
   Report ("hash", stop - start);
-  
+
 }
 
 void
 LookupTimeTestCase::DoSetup (void)
 {
   uint32_t nids = TypeId::GetRegisteredN ();
-  
+
   cout << suite << "Lookup time: reps: " << REPETITIONS
        << ", num TypeId's: " << nids
        << endl;
@@ -403,14 +413,14 @@
 {
   double nids = TypeId::GetRegisteredN ();
   double reps = nids * REPETITIONS;
-  
+
   double per = 1E6 * double(delta) / (reps * double(CLOCKS_PER_SEC));
-  
+
   cout << suite << "Lookup time: by " << how << ": "
        << "ticks: " << delta
        << "\tper: "   << per
        << " microsec/lookup"
-       << endl;					
+       << endl;
 }
 
 
@@ -423,13 +433,13 @@
 public:
   TypeIdTestSuite ();
 };
-  
+
 TypeIdTestSuite::TypeIdTestSuite ()
   : TestSuite ("type-id", UNIT)
 {
   // Turn on logging, so we see the result of collisions
-  LogComponentEnable ("TypeId", ns3::LogLevel(LOG_ERROR|LOG_PREFIX_FUNC));
-  
+  LogComponentEnable ("TypeId", ns3::LogLevel (LOG_ERROR | LOG_PREFIX_FUNC));
+
   // If the CollisionTestCase is performed before the
   // UniqueIdTestCase, the artificial collisions added by
   // CollisionTestCase will show up in the list of TypeIds
@@ -439,15 +449,15 @@
   AddTestCase (new DeprecatedAttributeTestCase, QUICK);
 }
 
-static TypeIdTestSuite g_TypeIdTestSuite;  
-  
+static TypeIdTestSuite g_TypeIdTestSuite;
+
 
 class TypeIdPerformanceSuite : public TestSuite
 {
 public:
   TypeIdPerformanceSuite ();
 };
-  
+
 TypeIdPerformanceSuite::TypeIdPerformanceSuite ()
   : TestSuite ("type-id-perf", PERFORMANCE)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/test/type-traits-test-suite.cc ns-3.31/src/core/test/type-traits-test-suite.cc
--- ns-3.30.1/src/core/test/type-traits-test-suite.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/test/type-traits-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
@@ -29,8 +29,8 @@
 
 namespace ns3 {
 
-  namespace tests {
-    
+namespace tests {
+
 
 /**
  * \ingroup object-tests
@@ -42,7 +42,8 @@
   /** Constructor. */
   TypeTraitsTestCase ();
   /** Destructor. */
-  virtual ~TypeTraitsTestCase () {}
+  virtual ~TypeTraitsTestCase ()
+  {}
 
 private:
   virtual void DoRun (void);
@@ -50,30 +51,29 @@
 
 TypeTraitsTestCase::TypeTraitsTestCase (void)
   : TestCase ("Check type traits")
-{
-}
+{}
 
 void
 TypeTraitsTestCase::DoRun (void)
 {
   NS_TEST_ASSERT_MSG_EQ
-    (TypeTraits<void (TypeTraitsTestCase::*) (void)>::IsPointerToMember, 1,
-     "Check pointer to member function (void)");
+    (TypeTraits<void (TypeTraitsTestCase::*)(void)>::IsPointerToMember, 1,
+    "Check pointer to member function (void)");
   NS_TEST_ASSERT_MSG_EQ
-    (TypeTraits<void (TypeTraitsTestCase::*) (void) const>::IsPointerToMember, 1,
-     "Check pointer to member function (void) const");
+    (TypeTraits<void (TypeTraitsTestCase::*)(void) const>::IsPointerToMember, 1,
+    "Check pointer to member function (void) const");
   NS_TEST_ASSERT_MSG_EQ
-    (TypeTraits<void (TypeTraitsTestCase::*) (int)>::IsPointerToMember, 1,
-     "Check pointer to member function (int)");
+    (TypeTraits<void (TypeTraitsTestCase::*)(int)>::IsPointerToMember, 1,
+    "Check pointer to member function (int)");
   NS_TEST_ASSERT_MSG_EQ
-    (TypeTraits<void (TypeTraitsTestCase::*) (int) const>::IsPointerToMember, 1,
-     "Check pointer to member function (int) const");
+    (TypeTraits<void (TypeTraitsTestCase::*)(int) const>::IsPointerToMember, 1,
+    "Check pointer to member function (int) const");
   NS_TEST_ASSERT_MSG_EQ
-    (TypeTraits<void (TypeTraitsTestCase::*) (void) const>::PointerToMemberTraits::nArgs, 0,
-     "Check number of arguments for pointer to member function (void) const");
+    (TypeTraits<void (TypeTraitsTestCase::*)(void) const>::PointerToMemberTraits::nArgs, 0,
+    "Check number of arguments for pointer to member function (void) const");
   NS_TEST_ASSERT_MSG_EQ
-    (TypeTraits<void (TypeTraitsTestCase::*) (int) const>::PointerToMemberTraits::nArgs, 1,
-     "Check number of arguments for pointer to member function (int) const");
+    (TypeTraits<void (TypeTraitsTestCase::*)(int) const>::PointerToMemberTraits::nArgs, 1,
+    "Check number of arguments for pointer to member function (int) const");
 }
 
 /**
@@ -99,7 +99,7 @@
  */
 static TypeTraitsTestSuite g_typeTraitsTestSuite;
 
-    
-  }  // namespace tests
+
+}    // namespace tests
 
 }  // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/test/watchdog-test-suite.cc ns-3.31/src/core/test/watchdog-test-suite.cc
--- ns-3.30.1/src/core/test/watchdog-test-suite.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/test/watchdog-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
@@ -30,8 +30,8 @@
 
 namespace ns3 {
 
-  namespace tests {
-    
+namespace tests {
+
 
 /**
  * \ingroup timer-tests
@@ -53,10 +53,9 @@
   int  m_expiredArgument; //!< Argument supplied to expired Watchdog
 };
 
-WatchdogTestCase::WatchdogTestCase()
+WatchdogTestCase::WatchdogTestCase ()
   : TestCase ("Check that we can keepalive a watchdog")
-{
-}
+{}
 
 void
 WatchdogTestCase::Expire (int arg)
@@ -72,7 +71,7 @@
   m_expired = false;
   m_expiredArgument = 0;
   m_expiredTime = Seconds (0);
-  
+
   Watchdog watchdog;
   watchdog.SetFunction (&WatchdogTestCase::Expire, this);
   watchdog.SetArguments (1);
@@ -96,7 +95,7 @@
 {
 public:
   /** Constructor. */
-  WatchdogTestSuite()
+  WatchdogTestSuite ()
     : TestSuite ("watchdog")
   {
     AddTestCase (new WatchdogTestCase ());
@@ -110,6 +109,6 @@
 static WatchdogTestSuite g_watchdogTestSuite;
 
 
-  }  // namespace tests
+}    // namespace tests
 
 }  // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/wscript ns-3.31/src/core/wscript
--- ns-3.30.1/src/core/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -94,10 +94,6 @@
     conf.check_nonfatal(header_name='sys/stat.h', define_name='HAVE_SYS_STAT_H')
     conf.check_nonfatal(header_name='dirent.h', define_name='HAVE_DIRENT_H')
 
-    if conf.check_nonfatal(header_name='stdlib.h'):
-        conf.define('HAVE_STDLIB_H', 1)
-        conf.define('HAVE_GETENV', 1)
-
     conf.check_nonfatal(header_name='signal.h', define_name='HAVE_SIGNAL_H')
 
     # Check for POSIX threads
@@ -165,6 +161,7 @@
         'model/map-scheduler.cc',
         'model/heap-scheduler.cc',
         'model/calendar-scheduler.cc',
+        'model/priority-queue-scheduler.cc',
         'model/event-impl.cc',
         'model/simulator.cc',
         'model/simulator-impl.cc',
@@ -212,11 +209,16 @@
         'model/hash-fnv.cc',
         'model/hash.cc',
         'model/des-metrics.cc',
+        'model/ascii-file.cc',
         'model/node-printer.cc',
         'model/time-printer.cc',
         'model/show-progress.cc',
+        'model/system-wall-clock-timestamp.cc',
         ]
 
+    if (bld.env['ENABLE_EXAMPLES']):
+        core.source.append('model/example-as-test.cc')
+            
     core_test = bld.create_ns3_module_test_library('core')
     core_test.source = [
         'test/attribute-test-suite.cc',
@@ -243,6 +245,11 @@
         'test/type-id-test-suite.cc',
         ]
 
+    if (bld.env['ENABLE_EXAMPLES']):
+        core_test.source.extend([
+            'test/examples-as-tests-test-suite.cc',
+            ])
+
     headers = bld(features='ns3header')
     headers.module = 'core'
     headers.source = [
@@ -257,6 +264,7 @@
         'model/map-scheduler.h',
         'model/heap-scheduler.h',
         'model/calendar-scheduler.h',
+        'model/priority-queue-scheduler.h',
         'model/simulation-singleton.h',
         'model/singleton.h',
         'model/timer.h',
@@ -265,6 +273,7 @@
         'model/synchronizer.h',
         'model/make-event.h',
         'model/system-wall-clock-ms.h',
+        'model/system-wall-clock-timestamp.h',
         'model/empty.h',
         'model/callback.h',
         'model/object-base.h',
@@ -328,11 +337,16 @@
         'model/non-copyable.h',
         'model/build-profile.h',
         'model/des-metrics.h',
+        'model/ascii-file.h',
+        'model/ascii-test.h',
         'model/node-printer.h',
         'model/time-printer.h',
         'model/show-progress.h',
         ]
 
+    if (bld.env['ENABLE_EXAMPLES']):
+        headers.source.append('model/example-as-test.h')
+
     if sys.platform == 'win32':
         core.source.extend([
             'model/win32-system-wall-clock-ms.cc',
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/csma/bindings/modulegen__gcc_ILP32.py ns-3.31/src/csma/bindings/modulegen__gcc_ILP32.py
--- ns-3.30.1/src/csma/bindings/modulegen__gcc_ILP32.py	2019-08-12 17:00:27.000000000 -0700
+++ ns-3.31/src/csma/bindings/modulegen__gcc_ILP32.py	2020-06-27 17:38:30.000000000 -0700
@@ -33,11 +33,11 @@
     ## trace-helper.h (module 'network'): ns3::AsciiTraceHelper [class]
     module.add_class('AsciiTraceHelper', import_from_module='ns.network')
     ## trace-helper.h (module 'network'): ns3::AsciiTraceHelperForDevice [class]
-    module.add_class('AsciiTraceHelperForDevice', import_from_module='ns.network', allow_subclassing=True)
+    module.add_class('AsciiTraceHelperForDevice', allow_subclassing=True, import_from_module='ns.network')
     ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList [class]
     module.add_class('AttributeConstructionList', import_from_module='ns.core')
     ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList::Item [struct]
-    module.add_class('Item', import_from_module='ns.core', outer_class=root_module['ns3::AttributeConstructionList'])
+    module.add_class('Item', outer_class=root_module['ns3::AttributeConstructionList'], import_from_module='ns.core')
     typehandlers.add_type_alias('std::list< ns3::AttributeConstructionList::Item > const_iterator', 'ns3::AttributeConstructionList::CIterator')
     typehandlers.add_type_alias('std::list< ns3::AttributeConstructionList::Item > const_iterator*', 'ns3::AttributeConstructionList::CIterator*')
     typehandlers.add_type_alias('std::list< ns3::AttributeConstructionList::Item > const_iterator&', 'ns3::AttributeConstructionList::CIterator&')
@@ -46,17 +46,17 @@
     ## buffer.h (module 'network'): ns3::Buffer [class]
     module.add_class('Buffer', import_from_module='ns.network')
     ## buffer.h (module 'network'): ns3::Buffer::Iterator [class]
-    module.add_class('Iterator', import_from_module='ns.network', outer_class=root_module['ns3::Buffer'])
+    module.add_class('Iterator', outer_class=root_module['ns3::Buffer'], import_from_module='ns.network')
     ## packet.h (module 'network'): ns3::ByteTagIterator [class]
     module.add_class('ByteTagIterator', import_from_module='ns.network')
     ## packet.h (module 'network'): ns3::ByteTagIterator::Item [class]
-    module.add_class('Item', import_from_module='ns.network', outer_class=root_module['ns3::ByteTagIterator'])
+    module.add_class('Item', outer_class=root_module['ns3::ByteTagIterator'], import_from_module='ns.network')
     ## byte-tag-list.h (module 'network'): ns3::ByteTagList [class]
     module.add_class('ByteTagList', import_from_module='ns.network')
     ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator [class]
-    module.add_class('Iterator', import_from_module='ns.network', outer_class=root_module['ns3::ByteTagList'])
+    module.add_class('Iterator', outer_class=root_module['ns3::ByteTagList'], import_from_module='ns.network')
     ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator::Item [struct]
-    module.add_class('Item', import_from_module='ns.network', outer_class=root_module['ns3::ByteTagList::Iterator'])
+    module.add_class('Item', outer_class=root_module['ns3::ByteTagList::Iterator'], import_from_module='ns.network')
     ## callback.h (module 'core'): ns3::CallbackBase [class]
     module.add_class('CallbackBase', import_from_module='ns.core')
     ## csma-channel.h (module 'csma'): ns3::CsmaDeviceRec [class]
@@ -64,27 +64,27 @@
     ## data-rate.h (module 'network'): ns3::DataRate [class]
     module.add_class('DataRate', import_from_module='ns.network')
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeAccessor> [struct]
-    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::AttributeAccessor'])
+    module.add_class('DefaultDeleter', template_parameters=['ns3::AttributeAccessor'], import_from_module='ns.core')
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeChecker> [struct]
-    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::AttributeChecker'])
+    module.add_class('DefaultDeleter', template_parameters=['ns3::AttributeChecker'], import_from_module='ns.core')
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeValue> [struct]
-    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::AttributeValue'])
+    module.add_class('DefaultDeleter', template_parameters=['ns3::AttributeValue'], import_from_module='ns.core')
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::CallbackImplBase> [struct]
-    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::CallbackImplBase'])
+    module.add_class('DefaultDeleter', template_parameters=['ns3::CallbackImplBase'], import_from_module='ns.core')
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::EventImpl> [struct]
-    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::EventImpl'])
+    module.add_class('DefaultDeleter', template_parameters=['ns3::EventImpl'], import_from_module='ns.core')
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::Hash::Implementation> [struct]
-    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::Hash::Implementation'])
+    module.add_class('DefaultDeleter', template_parameters=['ns3::Hash::Implementation'], import_from_module='ns.core')
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::NixVector> [struct]
-    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::NixVector'])
+    module.add_class('DefaultDeleter', template_parameters=['ns3::NixVector'], import_from_module='ns.core')
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::OutputStreamWrapper> [struct]
-    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::OutputStreamWrapper'])
+    module.add_class('DefaultDeleter', template_parameters=['ns3::OutputStreamWrapper'], import_from_module='ns.core')
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::Packet> [struct]
-    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::Packet'])
+    module.add_class('DefaultDeleter', template_parameters=['ns3::Packet'], import_from_module='ns.core')
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::QueueItem> [struct]
-    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::QueueItem'])
+    module.add_class('DefaultDeleter', template_parameters=['ns3::QueueItem'], import_from_module='ns.core')
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::TraceSourceAccessor> [struct]
-    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::TraceSourceAccessor'])
+    module.add_class('DefaultDeleter', template_parameters=['ns3::TraceSourceAccessor'], import_from_module='ns.core')
     ## event-id.h (module 'core'): ns3::EventId [class]
     module.add_class('EventId', import_from_module='ns.core')
     ## hash.h (module 'core'): ns3::Hasher [class]
@@ -128,7 +128,7 @@
     typehandlers.add_type_alias('std::vector< ns3::Ptr< ns3::Node > > const_iterator*', 'ns3::NodeContainer::Iterator*')
     typehandlers.add_type_alias('std::vector< ns3::Ptr< ns3::Node > > const_iterator&', 'ns3::NodeContainer::Iterator&')
     ## object-base.h (module 'core'): ns3::ObjectBase [class]
-    module.add_class('ObjectBase', import_from_module='ns.core', allow_subclassing=True)
+    module.add_class('ObjectBase', allow_subclassing=True, import_from_module='ns.core')
     ## object.h (module 'core'): ns3::ObjectDeleter [struct]
     module.add_class('ObjectDeleter', import_from_module='ns.core')
     ## object-factory.h (module 'core'): ns3::ObjectFactory [class]
@@ -136,19 +136,19 @@
     ## packet-metadata.h (module 'network'): ns3::PacketMetadata [class]
     module.add_class('PacketMetadata', import_from_module='ns.network')
     ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item [struct]
-    module.add_class('Item', import_from_module='ns.network', outer_class=root_module['ns3::PacketMetadata'])
+    module.add_class('Item', outer_class=root_module['ns3::PacketMetadata'], import_from_module='ns.network')
     ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item::ItemType [enumeration]
     module.add_enum('ItemType', ['PAYLOAD', 'HEADER', 'TRAILER'], outer_class=root_module['ns3::PacketMetadata::Item'], import_from_module='ns.network')
     ## packet-metadata.h (module 'network'): ns3::PacketMetadata::ItemIterator [class]
-    module.add_class('ItemIterator', import_from_module='ns.network', outer_class=root_module['ns3::PacketMetadata'])
+    module.add_class('ItemIterator', outer_class=root_module['ns3::PacketMetadata'], import_from_module='ns.network')
     ## packet.h (module 'network'): ns3::PacketTagIterator [class]
     module.add_class('PacketTagIterator', import_from_module='ns.network')
     ## packet.h (module 'network'): ns3::PacketTagIterator::Item [class]
-    module.add_class('Item', import_from_module='ns.network', outer_class=root_module['ns3::PacketTagIterator'])
+    module.add_class('Item', outer_class=root_module['ns3::PacketTagIterator'], import_from_module='ns.network')
     ## packet-tag-list.h (module 'network'): ns3::PacketTagList [class]
     module.add_class('PacketTagList', import_from_module='ns.network')
     ## packet-tag-list.h (module 'network'): ns3::PacketTagList::TagData [struct]
-    module.add_class('TagData', import_from_module='ns.network', outer_class=root_module['ns3::PacketTagList'])
+    module.add_class('TagData', outer_class=root_module['ns3::PacketTagList'], import_from_module='ns.network')
     ## log.h (module 'core'): ns3::ParameterLogger [class]
     module.add_class('ParameterLogger', import_from_module='ns.core')
     ## pcap-file.h (module 'network'): ns3::PcapFile [class]
@@ -158,23 +158,30 @@
     ## trace-helper.h (module 'network'): ns3::PcapHelper::DataLinkType [enumeration]
     module.add_enum('DataLinkType', ['DLT_NULL', 'DLT_EN10MB', 'DLT_PPP', 'DLT_RAW', 'DLT_IEEE802_11', 'DLT_LINUX_SLL', 'DLT_PRISM_HEADER', 'DLT_IEEE802_11_RADIO', 'DLT_IEEE802_15_4', 'DLT_NETLINK'], outer_class=root_module['ns3::PcapHelper'], import_from_module='ns.network')
     ## trace-helper.h (module 'network'): ns3::PcapHelperForDevice [class]
-    module.add_class('PcapHelperForDevice', import_from_module='ns.network', allow_subclassing=True)
+    module.add_class('PcapHelperForDevice', allow_subclassing=True, import_from_module='ns.network')
     ## queue-size.h (module 'network'): ns3::QueueSize [class]
     module.add_class('QueueSize', import_from_module='ns.network')
     ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Object, ns3::ObjectBase, ns3::ObjectDeleter> [class]
-    module.add_class('SimpleRefCount', import_from_module='ns.core', memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'), automatic_type_narrowing=True, parent=root_module['ns3::ObjectBase'], template_parameters=['ns3::Object', 'ns3::ObjectBase', 'ns3::ObjectDeleter'])
+    module.add_class('SimpleRefCount', parent=root_module['ns3::ObjectBase'], automatic_type_narrowing=True, memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'), template_parameters=['ns3::Object', 'ns3::ObjectBase', 'ns3::ObjectDeleter'], import_from_module='ns.core')
     ## simulator.h (module 'core'): ns3::Simulator [class]
-    module.add_class('Simulator', import_from_module='ns.core', destructor_visibility='private')
+    module.add_class('Simulator', destructor_visibility='private', import_from_module='ns.core')
     ## simulator.h (module 'core'): ns3::Simulator [enumeration]
     module.add_enum('', ['NO_CONTEXT'], outer_class=root_module['ns3::Simulator'], import_from_module='ns.core')
     ## tag.h (module 'network'): ns3::Tag [class]
-    module.add_class('Tag', import_from_module='ns.network', parent=root_module['ns3::ObjectBase'])
+    module.add_class('Tag', parent=root_module['ns3::ObjectBase'], import_from_module='ns.network')
     ## tag-buffer.h (module 'network'): ns3::TagBuffer [class]
     module.add_class('TagBuffer', import_from_module='ns.network')
+    ## nstime.h (module 'core'): ns3::Time [class]
+    module.add_class('Time', import_from_module='ns.core')
+    ## nstime.h (module 'core'): ns3::Time::Unit [enumeration]
+    module.add_enum('Unit', ['Y', 'D', 'H', 'MIN', 'S', 'MS', 'US', 'NS', 'PS', 'FS', 'LAST'], outer_class=root_module['ns3::Time'], import_from_module='ns.core')
+    typehandlers.add_type_alias('void ( * ) ( ns3::Time )', 'ns3::Time::TracedCallback')
+    typehandlers.add_type_alias('void ( * ) ( ns3::Time )*', 'ns3::Time::TracedCallback*')
+    typehandlers.add_type_alias('void ( * ) ( ns3::Time )&', 'ns3::Time::TracedCallback&')
     ## nstime.h (module 'core'): ns3::TimeWithUnit [class]
     module.add_class('TimeWithUnit', import_from_module='ns.core')
     ## traced-value.h (module 'core'): ns3::TracedValue<unsigned int> [class]
-    module.add_class('TracedValue', import_from_module='ns.core', template_parameters=['unsigned int'])
+    module.add_class('TracedValue', template_parameters=['unsigned int'], import_from_module='ns.core')
     ## type-id.h (module 'core'): ns3::TypeId [class]
     module.add_class('TypeId', import_from_module='ns.core')
     ## type-id.h (module 'core'): ns3::TypeId::AttributeFlag [enumeration]
@@ -182,9 +189,9 @@
     ## type-id.h (module 'core'): ns3::TypeId::SupportLevel [enumeration]
     module.add_enum('SupportLevel', ['SUPPORTED', 'DEPRECATED', 'OBSOLETE'], outer_class=root_module['ns3::TypeId'], import_from_module='ns.core')
     ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation [struct]
-    module.add_class('AttributeInformation', import_from_module='ns.core', outer_class=root_module['ns3::TypeId'])
+    module.add_class('AttributeInformation', outer_class=root_module['ns3::TypeId'], import_from_module='ns.core')
     ## type-id.h (module 'core'): ns3::TypeId::TraceSourceInformation [struct]
-    module.add_class('TraceSourceInformation', import_from_module='ns.core', outer_class=root_module['ns3::TypeId'])
+    module.add_class('TraceSourceInformation', outer_class=root_module['ns3::TypeId'], import_from_module='ns.core')
     typehandlers.add_type_alias('uint32_t', 'ns3::TypeId::hash_t')
     typehandlers.add_type_alias('uint32_t*', 'ns3::TypeId::hash_t*')
     typehandlers.add_type_alias('uint32_t&', 'ns3::TypeId::hash_t&')
